SystemOrganization addCategory: #TOcurricula!
SystemOrganization addCategory: #'TOcurricula-Tests'!

TestCase subclass: #ObservadorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula-Tests'!

Object subclass: #BuilderCurso
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

!BuilderCurso methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 21:12'!
addCodigo: cod
	! !

!BuilderCurso methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 21:13'!
addCreditos: cred! !

!BuilderCurso methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 21:15'!
addHrsPrac: hrs! !

!BuilderCurso methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 21:15'!
addHrsTeo: hrs! !

!BuilderCurso methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 21:15'!
addHrsTeoPrac: hrs! !

!BuilderCurso methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 21:15'!
addHrsTotal: hrs! !

!BuilderCurso methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 21:13'!
addNombre: nom! !

!BuilderCurso methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 21:14'!
addPrerequisito: prereq! !

!BuilderCurso methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 21:14'!
addSemestre: sem! !

!BuilderCurso methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 21:16'!
getCurso! !

BuilderCurso subclass: #BuilderCursoCompleto
	instanceVariableNames: 'cursoActual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

!BuilderCursoCompleto methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 21:33'!
addCodigo: cod
	cursoActual codigo: cod! !

!BuilderCursoCompleto methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 21:48'!
addCreditos: cred
	cursoActual creditos: cred ! !

!BuilderCursoCompleto methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 22:48'!
addHrsPrac: hrs
	cursoActual hrsprac: hrs! !

!BuilderCursoCompleto methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 22:47'!
addHrsTeo: hrs
	cursoActual hrsteo: hrs! !

!BuilderCursoCompleto methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 22:47'!
addHrsTeoPrac: hrs
	cursoActual hrsteoprac: hrs! !

!BuilderCursoCompleto methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 22:46'!
addHrsTotal: hrs
	cursoActual hrstotal: hrs! !

!BuilderCursoCompleto methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 21:34'!
addNombre: nom
	cursoActual nombre: nom! !

!BuilderCursoCompleto methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 22:45'!
addPrerequisito: prereq
	cursoActual prereqs: prereq ! !

!BuilderCursoCompleto methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 22:45'!
addSemestre: sem
	cursoActual semestre: sem! !

!BuilderCursoCompleto methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 21:30'!
getCurso
	^cursoActual ! !

!BuilderCursoCompleto methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 22:42'!
initialize
	cursoActual := 	Curso new! !

Object subclass: #Consultor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

!Consultor methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 23:17'!
cargarData
	| data jsonObject subs tam |
	jsonObject := self conectar.
	data := OrderedCollection new.
	subs :=	jsonObject at: 'feed'.
	subs := subs at: 'entry'.
	tam := subs size .
	1 to: tam do: [:pos | 
		| const |
		const := BuilderCursoCompleto new.
		data add: (self crearCurso: const param: (subs at: pos))
	].
	^data! !

!Consultor methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 22:07'!
conectar
	| dir parser jsonObject json |
	dir := 'http://spreadsheets.google.com/feeds/list/0AjE_p7Re6WDHdEJKUEVIM0dLWlY1TjRPZnQ1ZnVyVGc/od6/public/values?alt=json'.
	parser := PPParserResource current parserAt: PPJsonParser.
	json := (Url absoluteFromText: dir) retrieveContents contents.
	jsonObject := parser parse: json.
	^jsonObject 
! !

!Consultor methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 22:51'!
crearCurso: constructor param: tupla
	constructor addCodigo: ((tupla at: 'gsx$codigo') at: '$t').
	constructor addNombre: ((tupla at: 'gsx$nombre') at: '$t').
	constructor addCreditos: ((tupla at: 'gsx$cred') at: '$t').
	constructor addSemestre: ((tupla at: 'gsx$semestre') at: '$t').
	constructor addPrerequisito: ((tupla at: 'gsx$prereq1') at: '$t').
	constructor addPrerequisito: ((tupla at: 'gsx$prereq2') at: '$t').
	constructor addPrerequisito: ((tupla at: 'gsx$prereq3') at: '$t').
	constructor addPrerequisito: ((tupla at: 'gsx$prereq4') at: '$t').
	constructor addHrsTeo: ((tupla at: 'gsx$hrsteoria') at: '$t').
	constructor addHrsPrac: ((tupla at: 'gsx$hrsprac') at: '$t').
	constructor addHrsTeoPrac: ((tupla at: 'gsx$hrsteoprac') at: '$t').
	constructor addHrsTotal: ((tupla at: 'gsx$hrstotal') at: '$t').
	^ (constructor getCurso)! !

Object subclass: #Curso
	instanceVariableNames: 'codigo nombre creditos semestre hrstotal hrsprac hrsteo hrsteoprac prereqs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:13'!
codigo
	^codigo! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:09'!
codigo: cod
	codigo := cod! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:14'!
creditos
	^creditos ! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:11'!
creditos: cred
	creditos := cred! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:18'!
hrsprac 
	^hrsprac ! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:11'!
hrsprac: hrs
	hrsprac := hrs! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:18'!
hrsteo 
	^hrsteo ! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:11'!
hrsteo: hrs
	hrsteo := hrs! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:18'!
hrsteoprac 
	^hrsteoprac ! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:12'!
hrsteoprac: hrs
	hrsteoprac := hrs ! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:18'!
hrstotal
	^hrstotal ! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:10'!
hrstotal: hrs
	hrstotal := hrs! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 12:21'!
info
	| cad |
	cad  :=	'Codigo: ', self codigo , String cr,
			'Nombre: ', self nombre , String cr,
			'Creditos: ', self creditos , String cr,
			'Semestre: ', self semestre , String cr,
			'Hrs Teoria: ', self hrsteo , String cr,
			'Hrs Practica: ', self hrsteoprac , String cr,
			'Hrs TeoricoPracticas: ', self hrsteoprac , String cr,
			'Horas totales: ', self hrstotal.
	^cad! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 22:37'!
initialize 
	prereqs := OrderedCollection new.! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:14'!
nombre
	^nombre! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:10'!
nombre: nom
	nombre := nom! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:21'!
prereqs
	^prereqs! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 22:37'!
prereqs: setReqs
	prereqs add: setReqs ! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 12:19'!
semestre
	^semestre! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 12:19'!
semestre: sem
	semestre := sem! !

Object subclass: #IteradorMalla
	instanceVariableNames: 'posicion malla'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

!IteradorMalla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:48'!
hasNext
	( posicion <= (malla numCursos) ) ifTrue: [
		^true] 
	ifFalse: [
		^false]! !

!IteradorMalla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:49'!
init: mall
	malla := mall.
	posicion := 1! !

!IteradorMalla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 14:26'!
next
	| cur |
	cur := malla getCursoIn: posicion .
	posicion := posicion + 1.
	^cur ! !

Object subclass: #Observador
	instanceVariableNames: 'observador'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

!Observador methodsFor: 'as yet unclassified' stamp: 'ruth 11/17/2012 15:42'!
actualizar: sujetoNuevo
	  ^ 0
	! !

Observador subclass: #Visualizador
	instanceVariableNames: 'malla'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

!Visualizador methodsFor: 'as yet unclassified' stamp: 'ruth 11/19/2012 09:55'!
actualizar: suj
	(suj = malla) ifTrue: [self dibujar]
	! !

!Visualizador methodsFor: 'as yet unclassified' stamp: 'ruth 11/19/2012 10:01'!
delete
	malla quitar: self! !

!Visualizador methodsFor: 'as yet unclassified' stamp: 'ruth 11/19/2012 10:22'!
dibujar
	| view it |
	view := MOViewRenderer new.
	"Aplicando patron ITERATOR"
	it := malla iterador.
	
	[it hasNext] whileTrue: [
		| cur cod req |
		"Este mensaje se mostrar cuando se pasa el Mouse sobre el cuadro"
		view interaction popupText: [:entity | 
			self mostrarInfo: (entity)
		].
		
		"Establecemos una accion de informacion cuando se haga clic en el nodo"
		view interaction on: MOMouseDouble do: [ :ann | 
			self inform: (self mostrarInfo: (ann model))
		].
		cur := it next.
		cod :=  cur codigo.
		view shape rectangle width: 50; withText; fontSize: 10.
		view node: cod.		
		view shape: (MOArrowedOrthoVerticalLineShape new).
		"Aqui analizamos los prerequisitos de cada uno de los cursos, para mostrar la relacion entre ambos"
		1 to: (cur prereqs) size do: [:j |
			req := (cur prereqs) at: j.
			(req = '' | req = ' ') ifFalse: [
				view edges: { req -> cod } from: #key to: #value ]
		].
	].
	view treeLayout.
	view open ! !

!Visualizador methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 23:09'!
initialize 
	malla := Malla new.
	malla adjuntar: self
	
	! !

!Visualizador methodsFor: 'as yet unclassified' stamp: 'ruth 11/19/2012 05:30'!
mostrarInfo: codigo
	| cur |
	cur := malla getCurso: codigo.
	^ (cur info)! !

Observador subclass: #Visualizador2
	instanceVariableNames: 'malla'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

!Visualizador2 methodsFor: 'as yet unclassified' stamp: 'ruth 11/19/2012 05:23'!
mostrarFrom: nomSource
	| view it |
	view := MOViewRenderer new.
	"Aplicando patron ITERATOR"
	malla := Malla new.
	it := malla iterador.
	
	[it hasNext] whileTrue: [
		| cur cod req |
		"Este mensaje se mostrar cuando se pasa el Mouse sobre el cuadro"
		view interaction popupText: [:entity | 
			self mostrarInfo: (entity)
		].
		
		"Establecemos una accion de informacion cuando se haga clic en el nodo"
		view interaction on: MOMouseDouble do: [ :ann | 
			self inform: (self mostrarInfo: (ann model))
		].
		cur := it next.
		cod :=  cur codigo.
		view shape rectangle width: 50; withText; fontSize: 10.
		view node: cod.		
		view shape: (MOArrowedOrthoVerticalLineShape new).
		"Aqui analizamos los prerequisitos de cada uno de los cursos, para mostrar la relacion entre ambos"
		1 to: (cur prereqs) size do: [:j |
			req := (cur prereqs) at: j.
			(req = '' | req = ' ') ifFalse: [
				view edges: { req -> cod } from: #key to: #value ]
		].
	].
	view treeLayout.
	view open ! !

!Visualizador2 methodsFor: 'as yet unclassified' stamp: 'ruth 11/19/2012 05:17'!
mostrarInfo: codigo
	| cur matAux info |
	cur := malla getCurso: codigo.
	^ (cur info)! !

Object subclass: #Sujeto
	instanceVariableNames: 'listObservers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

Sujeto subclass: #Malla
	instanceVariableNames: 'cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

!Malla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:34'!
add: cur
	cursos add: cur! !

!Malla methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 23:05'!
buscar: codigo
	| i enc|
	i := 0.
	enc := 0.
	[enc = 0] whileTrue: [
		i := i + 1.
		((cursos at: i) codigo = codigo ) ifTrue: [enc := 1]
	].
	(enc = 1) ifTrue: [^i] ifFalse: [^nil]! !

!Malla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:16'!
cursos
	^cursos! !

!Malla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:16'!
cursos: cur
	cursos := cur! !

!Malla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:20'!
getCurso: cod
	| pos |
	pos := self buscar: cod.
	^(cursos at: pos)! !

!Malla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 14:25'!
getCursoIn: pos
	^(cursos at: pos)! !

!Malla methodsFor: 'as yet unclassified' stamp: 'AngelaGabrielaMayhuaQuispe 12/14/2012 23:17'!
initialize 
	super initialize.
	cursos := Consultor new cargarData		"Cargamos la matriz de los cursos que tenemos almacenados"! !

!Malla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:27'!
iterador
	^(IteradorMalla new init: self)! !

!Malla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:23'!
numCursos
	^cursos size! !

!Sujeto methodsFor: 'as yet unclassified' stamp: 'ruth 11/19/2012 09:29'!
adjuntar: obs
	listObservers add: obs 
	

	! !

!Sujeto methodsFor: 'as yet unclassified' stamp: 'ruth 11/19/2012 10:14'!
initialize
	listObservers := OrderedCollection new! !

!Sujeto methodsFor: 'as yet unclassified' stamp: 'ruth 11/19/2012 10:42'!
notificar
	1 to: listObservers size do: [:pos | 
		(listObservers at: pos) actualizar: self
		]
	 ! !

!Sujeto methodsFor: 'as yet unclassified' stamp: 'ruth 11/19/2012 09:38'!
quitar: obs
	listObservers remove: obs
	
	! !
